Introduction
 Top Next

WinTRAX

Raytracing beam optics software for Windows

by

Geoffrey W. Grime
gwg@microbeams.co.uk

WinTRAX is distributed free of charge. The author does not guarantee that results from this software will be correct or accurate and does not accept responsibility for any loss, damage or injury arising in any way from the use of this software.

Any use of this software in any form of publication, presentation or design document must be acknowledged by quoting the following reference:

G.W. Grime (2013), 'WinTRAX: A raytracing software package for the design of multipole focusing systems'.
Nuclear Instruments and Methods B: Volume 306, 1 July 2013, Pages 76–80
http://dx.doi.org/10.1016/j.nimb.2012.11.038

Downloaded from www.microbeams.co.uk

A PDF of this paper has been supplied in the installation folder.

Please send any bug reports, comments or suggestions for additional features to the above email address.


History
 Previous Top Next

Modelling quadrupole focusing systems for micro and nanobeam probe-forming applications is a serious challenge for any software package. The fact that the resultant ray displacements may lie within a range of several orders of magnitude (nanometres to millimetres) and that the approximations entailed in analytical solutions may result in errors significantly larger than the desired spot size means that the method of choice is effectively restricted to high precision numerical ray tracing of particles through mathematically modelled electrostatic and magnetic fields. On the other hand the fact that microprobe beamlines are usually straight, with no intentional bends, allows the assumption that all the elements lie on a straight axis, which permits a significant simplification of the mathematics.

One of the earliest programs of this type specifically designed for nuclear microbeam modelling was OXRAY [1,2]. This was written in FORTRAN for the DEC PDP-10/20 series of mainframe computers and employed an analytical model of cylindrical harmonic fields with fringing fields to describe the active elements. In the late 1980s OXRAY was re-written for the VMS operating system on the VAX computers and became TRAX. The basic computation strategy remained the same, but the text-based user interface was improved and new optimisation and output options were added. TRAX remained one of the default programs for microbeam modelling even after the phasing out of VAX-VMS (when it could be run on only a few legacy machines) and was described by Incerti et al. in 2005 as the “reference raytracing tool in use today among the microbeam community” [3].

Renewed interest in new designs of beamlines and scanning systems has led again to a requirement for simple to use high performance beam optics software, and TRAX has now been re-written yet again, this time in C++ for the Windows environment. This is WinTRAX.

1. G.W. Grime and F.Watt, Beam Optics of Quadrupole Probe-Forming Systems, Adam Hilger Ltd. Bristol, 1983.

2. G.W. Grime, et al., Nucl. Instr. and Meth. 197 (1982) 97.

3. S. Incerti et al., Nucl. Instr. and Meth. B 231 (2005) 76-85.


Brief summary (Quick start)

The following notes are provided for guidance.

Example data files
A set of example data files are provided in the Examples folder of the installation folder.

Commands
Commands are either menu selections from the main menu , buttons from dialog boxes or text commands entered into the console window

The Layout tool
If you are starting from a dimensioned beamline sketch, use the Layout window to position elements according to their distance from the origin or by their separation before creating the full data file.

Defining and modifying system parameters
The system definition window is a permanent feature of the WinTRAX screen.

Use Load, Save and Save as to load and save system files (*.txsx).

Add an element using Add or Clone.

New or Edit or double click on an element brings up the element definition window .

Delete the selected element using Delete

A system should contain a source and one or more active elements. Viewing screens should be inserted at points where beam properties are required. Apertures and beam tubes can be used to define the beam shape or assess beam clipping.

Defining an element
Elements are numbered simply by the order in which they were defined and are referred to as, for example as MQU2, LNK14, SLI5. If you use the layout tool for the initial specification, elements will be numbered by their distance from the origin.

Element positions are defined as the distance from the origin (z=0, source position) to the geometric centre of the element.

Use the element definition window . The following elements can be defined:
Source | Defines the ion, energy and phase space parameters of the beam at the entrance to the system. Each system must have only one source as the first element.
Active element New! | A superposition of one or more axially aligned cylindrical harmonic or axial fields. The element is described by its 'headline multipole', which also defines its length for display purposes. All other field components are considered as small contaminants. Axial field focusing elements (solenoids or gap lenses) can also be defined.
Slit | An elliptical, rectangular or grid shaped blocking aperture.
Screen | A 'viewing screen' which is inserted at points where the beam properties are required.
Tube | A rectangular or elliptical cross section beam tube.
Link blocks | Element parameters can be linked arithmetically to a single value through a link block . The common value can be defined using the parameter VALUE

Each element type has its own definition window.

Raytracing
Trace a single ray using the SINGLE command. Define the x,y,th,ph and de of the entrance ray

Define a multiple ray set for beam tracing using the Raytracing control panel . This allows the beam to be defined either by the source phase space or by random selection from the apertures of two slits in object space (one expected to be at the object position). Use the TRACE command to start a rayset. The total number of rays and the number or rays displayed in the ray plots can be defined.

The raytracing window also allows the control parameters for the DE solver to be defined and whether the slits and tubes are active (blocking) or not.

Beam envelope projections
The Beam envelope window shows the X and Y projections of the beam. The vertical (X and Y) scales are independently automatically scaled to display the full envelope. The z scale can be zoomed using the 'zoom' button (click lower and upper z positions for the zoom) and reset with the Reset button. The rayset can be cleared using the Clear button.

Individual rays may show discontinuities. These show the points where the Pre-Corr DE solver changes the step size. This only affects the ray plots and does not reflect the accuracy of the result at the screens. See the Raytracing control panel for more details.

Viewing screens
Each viewing screen defined appears as a separate tab in the Viewing screen window. This displays three 2-D projections (x-y, x-th and y-ph) of the 4-D phase space at that point. The appearance of the 2-D plots can be changed (colour palette, number of pixels, dimensions), and the plots can be copied to the clipboard.

Optimising
The Optimise command from the main menu displays the Optimisation window . This allows one of many conditions (e.g. minimum radius, position = value) to be achieved at a selected screen by varying one or more element parameters. The parameters of the simplex optimiser (initial stepsize range, stopping accuracy) can be defined.

Each optimisation run is saved in the system data fileunder the name entered in the description field and can be re-loaded for repeat operation.

Aberration coefficients.
Aberration coefficients are calculated using the Genfit menu item or the GENFIT text command. This brings up the GENFIT control panel where the variables and dimensions of the rays traced to make the coefficients are defined. The calculated aberration coefficients and the exit rayset are displayed and can be saved in CSV files.


Text commands

Commands can be typed into the console window to either initiate actions or to modify element parameters. Commands or parameter names can be in upper or lower case and can be abbreviated to any unique string.

Commands
GENFIT | Start an aberration coefficient calculation
SINGLE | Trace a single ray
HELP | Type a list of commands
TRACE | Start a beam trace with the current conditions
OPTIM | Launches an optimisation run
SAVE | Saves the system into its current filename

Parameter modification
Parameters can be changed using commands of the form

PAR [n1[,n2]] op value

where
PAR | A parameter symbol from the list below
n1, n2 | Optional element numbers to define the element or range of elements being changed
op | an operator from the list below
value | a numerical value

Operators
+ | par = par + value
- | par = par - value
* | par = par * value
/ | par = par / value
= | par = value
? | display parameter value
> N | save parameter in memory N
< N | par = value from memory N

Examples
KV3 = 5.75 K value of element 3 changes to 5.87
CEN 8,10 +0.5 Centres of elements 8 to 10 increase by 0.5 m
PT 3,8 ? Display the pole-tip fields of element 3 to 8.

List of parameters
Not all parameters are implemented
Symbol | Abbreviation | Description | Unit
KVAL | KV | k-valueof element | m^-1
PTF | PT | pole-tip field | T
EXC | EX | excitation | T or kV
PV | PV | pole voltage | kV
BAX | B | axial field (solenoid) | T
VGAP | VG | accelerating voltage (gap lens) | kV
CENTRE | CEN | centre | m
AA | A | mass | amu
QQ | Q | charge |
EIN | EIN | energy | MeV
VALUE | VAL | value of a link block |
RIPPLE | RIP | ripple | %
XSLIT | XS | x aperture | um
YSLIT | YS | y aperture | um
XOFF | dX | x offset | um
YOFF | dY | y offset | um
ZOFF | ZOFF | z offset | um
XTILT | dA | x tilt | mr
YTILT | dB | y tilt | mr
AXTILT | AXTILT | axial tilt | mr
ROT | RHO | rotation | mr
IMDIST | IMDIST | image distance | m
RAD | RAD | radius | mm
EFFLEN | EFFLEN | eff. length | m
EZMIN | EZMIN | ent. z0 | m
EZFL | EZFL | ent. Fringe length | m
XZMIN | XZMIN | exit z0 | m
XZFL | XZFL | exit fringe length | m
ECA | ECA | ent. c0 |
ECB | ECB | ent. c1 |
ECC | ECC | ent. c2 |
ECD | ECD | ent. c3 |
ECE | ECE | ent. c4 |
XCA | XCA | exit c0 |
XCB | XCB | exit c1 |
XCC | XCC | exit c2 |
XCD | XCD | exit c3 |
XCE | XCE | exit c4 |
XX | X | x | um
YY | Y | y | um
TH | TH | theta | mr
PH | PH | phi | mr
DE | DE | delta_p/p | %
XDRIF | XDRIF | x drift | m
YDRIF | YDRIF | y drift | m
ENSP | ENSP | Energy spread | keV
EPS | EPS | Field shift | %
MEM | MEM | Value |
NM | NM | Order |
NE | NE | Order |
ROUGH | ROUGH | Roughness | um
RSLIT | RSLIT | Radius | mm
ZSLIT | ZS | Atomic number of slit material | atomic number
GHOLE | GHOLE | Hole size | um
GBAR | GBAR | Bar size | um
ZGRID | ZGRID | Atomic number of grid material | atomic number
TGRID | TGRID | Thickness | um
AMP | A | Coil current | A
BGRAD | BGR | Magnetic field gradient | T/m^n-1
EGRAD | EGR | Electrostatic field gradient | kV/m^n
DVAL | dV | Static deviation of link value from design value (useful for determining sensitivity to value changes | %


Program components

On startup, the main window shows several permanent components:

· Main menu
· Console pane
· System definition window
· Raytracing control panel

Other dialog boxes and windows appear during the operation of the program.


Main window

The WinTRAX main window consists of two areas: a Console Window, where text commands can be typed and some status messages are displayed and the Workspace, where the various dialog boxes and output windows are created. The Console window can be sized by dragging the vertical separator bar. There is a menu bar to access commands.

The workspace contains two permanent windows, the System definition window amd the Raytracing control panel . Other windows are created as the program progresses.


Menu commands

Each main menu item reveals a sub-menu:
Top menu item | Sub-menu items | Action
File | Open .. | These commands control the creation, saving and loading of SYSTEM data files. System files have an extension .TXSX or *.TSX for older versions. These commands are replicated in the System definition window
 | New..
 | Save
 | Save as ..
 | Exit | Close the program
Fields |  | Commands to display the value of electrostatic or magnetic fields in the system.
 | Show field plots | Displays an axial graph of the fields in the system. This opens the System field plots window.
 | Spot fields | Displays the numerical value of the field at a defined point in the system or in a single element. Opens the Spot fields dialog.
Raytracing |  | Commands to initiate various raytracing procedures
 | Single ray | Traces a single ray through the system. The initial coordinates (X, Y in microns, th, ph in mr and dP/P in %) must be entered in a text entry box that pops up. The path of the ray is shown on the ray plot and the final coordinates are displayed in the console pane of the main window. This command is identical to the SIngle text command.
 | Trace | Initiates the tracing of a full rayset as defined in the Raytracing control panel . Equivalent to the TRace text command or the Start button in the control panel.
 | Optimise | Opens the Optimisation window to start an optimisation procedure. Equivalent to the OPTIM text command
 | Genfit (Aberration coefficients) | Opens the Aberration coefficient calculation window. Equivalent to the GENfit text command.
 | Matrix | Opens the Matrix calculation window to calculate the first order transfer matrices between two planes in the system.
 | Configure ray plot | Opens the Ray plot configuration window to define the colours for the beam envelope display.
Window |  | Commands for cascading and locating windows
Help |  | Help and About menu. If Keep updated is checked, then the program checks for a new version on startup. If one is available then this is downloaded in the background and may be installed automatically on exit.


System definition window

This window is a permanent feature of the desktop and manages the definition of elements and how they are grouped into systems.

Buttons in the top right manage the creation, saving and loading of system files:
Feature | Description
Layout | Opens the Layout tool dialog to define a new system.
Open | Reads a previously saved system data file from disk.
Save Save as | Saves the current system into a data file using either the current filename or a new one.
Save grid | Saves a summary of the system as a CSV file for reading as a spreadsheet.

The Description box allows a decription of th esystem to be entered (maximum 80 characters I think).

Elements are numbered in the sequence that they are added, and the short code for an element uses this sequence number (e.g. MQU6, SL2 in the above example).

To create the elements in a logical sequence use the Layout tool to define all the elements before using this screen.

To redefine the sequence after adding new elements use the ReOrder command described below.

Clicking on an element selects it. Double click opens the element for editing.

The element grid is read-only. Values can only be changed using the Element definition window or using the text commands in the console window.

The commands across the top of the grid relate to the individual elements as follows:
Feature | Description
Add | Adds a new element with the next available sequence number. This opens the Element definition window.
Edit | Edits the currently selected element (opens the Element definition window).
Clone | Creates a copy of the currently selected element at the end of the list.
Delete | Removes the currently selected element.
Clear | Removes all elements.
ReOrder | Re-numbers the elements in order of their distance from the source and repositions them in the list. This also changes the references in LINK blocks and stored GENFIT and OPTIM routines.


Layout window
From the System Definition window: Layout

Use this window to perform the initial layout of a system starting from a dimensioned sketch of the beamline.

This allows you to enter the elements in any order, specifying their location in several convenient ways. The elements are then automatically numbered in distance order. Layout files can be saved and loaded and when the basic layout is complete, the button 'Create system file' generates a WinTRAX system file and prompts for any information not already supplied.

The basic operations are:

Add
Creates a new element.
The Element type dropdown box specifies the type of the element. Multipoles must be furrther specified as magnetic or electrostatic and by multipole order.
The first element in a system must be a source, and this is forced by the logic of the window.

Each element MUST HAVE a unique Description in system which is used internally by the Layout tool. Blank or duplicate descriptions are not permitted.

If a data file exists for the element, use the Data filename browser button to locate this. The Layout tool will extract the information it requires from the file.

The Design length is the 'engineering' length of the element that would be used in a layout sketch, typically the length of the magnetic yoke or electrostatic plate. If a data file is specified, this is obtained from the file.

The Position of the element can be specified by entering the distance of its [Entrance | Centre | Exit] from the origin of the system or the [Centre | Exit] of a previously defined element.

When the element is fully defined, use << Add to system (for a new element) or << Save changes (after editing an existing element) to transfer the information to the system.

Edit (Click on the element in the list)
This highlights the slected element and allows the parameters to be modified. Changes are not recorded until the << Save changes button has been pressed.

Clone
Creates a copy of the selected element.

Delete
Removes the selected element from the list.

Clear All
Deletes all elements.

Layout file
The Load and Save buttons allow the Layout settings to be stored and recalled, for example to use a particular configuration to be used as the nucleus of a new system or simply to return to it later.

Create system file
This button transfers the layout information to a new WinTRAX system. During the transfer the program displays the element definition window for any element which is not fully specified. Linked parameters must be defined here using the Link block definition window .

Note that this operation is irrevocable. It is not possible to re-create a Layout file from a System file so any changes made to a system file are not reflected in the Layout.


Raytracing control panel

A permanent feature of the desktop.
This panel manages
· The operation of the differential equation (DE) solver.
· The way that rays are generated and plotted for the Trace command.
· The action of slits and beam tubes

This panel is more complex than it looks! Keep reading...

Start
This starts the raytracing run with the conditions defined. For the multiple ray options, a progress screen is displayed:

This runs as a separate application (WinTRAX sentry). Clicking the stop button or closing the program from the taskbar will stop the optimiser.

Solver settings
Absolute acc.
Relative acc.
These are the tolerances used by the DE solver. A step is deemed to be good if the deviation between the true values and the predicted values of the particle acceleration (V) at the end of the step satisfies the inequality
|dV| < A + R*|V|, where A is the absolute error and R is the relativeerror.

Experiment with these. Small values of R and A will give more accurate results but will greatly slow down the operation. Larger values may be used for quick evaluation of a system.
MACHEPS
The smallest real value that is assumed to be significant. This parameter is introduced to quantify the level of rounding errors in the calculations and stop the solver getting stuck around very small steps. Larger values reduce the accuracy, smaller values increase calculation time.
Max step size

Auto
The predictor-corrector DE solver used in the program automatically adjusts the axial step size to maintain the accuracy defined above. This can lead to short elements being skipped over if the step size s too long or discontinuities in the
ray plots at points where the step size changes. To avoid these problems, a maximum step size can be defined here (at the expense of calculation time). Uncheck Auto and set Max step size to a value less than the Min Z step value to get smooth ray plots.

The Auto option gives the fastest performance and should be used by default.
Max field calls per ray
The maximum number of field evaluations permitted for each ray. This provides a timeout if the solver gets stuck in a loop. The program does not flag when a ray stops because of this, so check this value if rays stop unexpectedly.

Rayset definition and plotting parameters
The TRACE menu or text command traces the rayset defined here.

The initial coordinates of the rays to be traced can be generated in three basic ways selected by the buttons at the top of the dialog.
Single ray | A single ray is traced using coordinates entered i the input boxes. Single ray tracing can be carried out more conveniently using the TRace text command or Raytracing | Single ray from the main menu.
Multiple rays | A set of many rays is generated by WinTRAX and traced to generate a beam. There are many options for doing this which are described below.
External rayset | A set of ray coordinates is loaded from an external file. This can be a CSV file created from another program or WinTRAX will also read TRANSMIT.TXT files generated by SRIM to allow the simulation of beams subject to scattering. This option is described here .

Multiple rays
These options define a multiple rayset. There are many options, some of which are not defined (in which case an error message is shown) or do not work properly...

The rays are plotted onto the Beam envelope window as they are traced when the Live Ray plot Enabled box is checked. This can introduce a significant delay as the rays are redrawn, so the frequency of plot updates can be controlled using the Refresh after ... rays box. This defines how many rays are accumulated between updates of the beam envelope window. In addition the maximum number of rays plotted can be limited using the Max rays per graph parameter.

Regardless of how the ray plotting is configured, all rays traced are recorded on the viewing screens and are displayed at th end of the sequence.

Rays can be generated as Stepped or Random
Stepped | The ray coordinates coordinates are generated by stepping a regular intervals defined by the source phase space and the Steps per Dimension parameter
Random | The ray coordinates are generated at random from within the selected phase space. The total number of rays is defined by the Number of rays parameter.

Ray coordinates can be defined by the source diameter and divergence or by two slits in the object space of the lens

Source
The source phase space can be defined as
Rectangular | All combinations of source coordinates within the extents defined by the source X and Y diameter and divergence are permitted.
Elliptical | The source coordinates are selected from upright ellipses defined by the source X and Y diameter and divergence. This option defines a beam optical waist at the source.
Gaussian | The ray coordinates are generated from gaussian distributions with fwhm equal to the defined source dimensions. In this mode there is no correlation between any of the transverse coordinates.

In these cases the coordinates can be selected from
The Volume of the phase space | Any combination of source coordinates within the phase space volume are permitted.
The Surface of the phase space volume | Only source coordinates lying on the surface of the phase space volume can be selected. This generates a rayset with the maximum possible extent and can be used to investigate beam clipping.

Two slits
In this option, the source coordinates are ignored and the rays are generated by linking random points in the aperture of two slits in the object space of the system. One slit is required to be at the source (equivalent to the object slit in a microbeam system) and the other should be in the space between the source and the first field region (collimator slit). This can be selected from the remaining silts in the system using the dropdown list. The >> Auto << option selects the first slit in the object space, but you can override this, for example if there is an anti-scattering slit between the object and the collimator.

Energy distribution
This option defines how the energy spread of the source is applied:
Monochromatic | No energy spread is used
Rectangular | Each ray has an energy shift selected randomly from a uniform distribution with a full width defined by the source energy spread.
Gaussian | Each ray has an energy shift selected randomly from a Gaussian distribution with a full width at half maximum defined by the source energy spread.

Slits and tubes
The blocking action of slits and tubes in the system can be turned on and off with the buttons
Slits active
Tubes active


Ray plot configuration
Main menu: Raytracing | Configure ray plot
Text command: (none)
Beam envelope window: "Rubik" button

Sets the colours for different elements of the beam envelope and ray plot.

Double-click on thefeature you wish to change and select a new colour from the standard Windows colour dialog that will pop up. Changes will be applied when the dialog is closed.

Frequently used colour schemes can be saved and loaded with the Store buttons.


Using externally generated raysets

The external rayset option of the Raytracing control panel allows the initial ray coordinates to be read from an externally generated file.

Use the Browse button to locate the source file. File formats are described below.

If the file has been read successfully the program displays the of the number of ions in the file and their mean energy. Use the >> Set in source button to transfer this energy to the soubce energy in the defined system.

If Convolute file X,Y... is checked then values selected randomly from the source area (defined in the System window) will be added to the X and Y coordinates in the file. This is useful, for example, when using TRIM files, where the initial beam has an extent of zero.

File formats

Two formats are recognised at present. Demo files are installed in the Examples folder.

CSV format
This is a comma separated variable text file (which can be written by Excel) which contains one line of data for each ion. There are no header lines.
Each line contains the following data:
Energy(MeV), X coord (um), Y coord (um), X divergence (th, mr), Y divergence (ph, mr)

This is the first few lines of the file CSV demo.CSV:
61.9828,27.21,7.431,30.39994204,19.56036705
61.81223,29.99,-12.58,33.18581459,-12.17960251
61.22811,6.21,2.073,-11.53631146,-17.39258637
60.85333,-17.22,7.032,-0.476967606,26.51431713
62.26063,-4.872,14.21,-15.43205987,-3.992106998
61.95154,-11.42,-3.734,-42.49044063,-12.55069969
61.48389,-34.49,59.2,-47.91183565,68.68771021
61.63818,16.97,4.838,13.9389384,27.0220815
62.47209,-3.394,-7.327,-13.53757324,-8.004389343
62.25954,-14.42,-19.72,-36.20898427,-38.2234707
61.93934,-0.3343,-46.95,-25.38436693,-102.5444399
61.81857,-13.23,-30.35,-21.1225195,-31.41718842
61.58412,-14.31,-33.15,-36.44212057,-58.9570077
61.22631,30.26,-22.44,25.75591692,-11.07845162
61.52143,26.33,-19.77,-27.79726679,-9.805956766
61.47453,-5.245,41.35,-12.6021864,76.58382895
61.52306,-21.15,5.56,-57.80932412,27.64448273
61.40463,-4.597,-6.923,24.99235604,-20.32443619
61.84304,3.557,30.21,11.45844705,55.01034129
61.76554,8.08,-2.375,-65.98079855,-4.42003302
61.57566,51.77,-7.674,62.56242205,2.795165107

TRIM format.
This option will read directly the TRANSMIT.TXT files generated by SRIM. It is assumed that the file uses the default units for energy and displacement (eV and angstrom).
Note that The lateral extent of the input beam in TRIM is zero, and so the Convolute X,Y option should be used to simulate an incident beam with non-zero extent.

Here is the start of the file TRIM demo.txt

=====================   Resuming TRIM Calculation ========================
=====================   18:44:36 on 07-28-2019   =========================
T 1114  1 .6198280E+08   1000000E+01  .2721E+06  .7431E+05   .9993473  .0303801  .0195476
T 1115  1 .6181223E+08   1000000E+01  .2999E+06 -.1258E+06   .9993758  .0331651 -.0121720
T 1116  1 .6122811E+08   1000000E+01  .6210E+05  .2073E+05   .9997823 -.0115338 -.0173888
T 1117  1 .6085333E+08   1000000E+01 -.1722E+06  .7032E+05   .9996486 -.0004768  .0265050
T 1118  1 .6226063E+08   1000000E+01 -.4872E+05  .1421E+06   .9998730 -.0154301 -.0039916
T 1119  1 .6195154E+08   1000000E+01 -.1142E+06 -.3734E+05   .9990200 -.0424488 -.0125384
T 1120  1 .6148389E+08   1000000E+01 -.3449E+06  .5920E+06   .9965116 -.0477447  .0684481
T 1121  1 .6163818E+08   1000000E+01  .1697E+06  .4838E+05   .9995381  .0139325  .0270096
T 1122  1 .6247209E+08   1000000E+01 -.3394E+05 -.7327E+05   .9998764 -.0135359 -.0080034
T 1123  1 .6225954E+08   1000000E+01 -.1442E+06 -.1972E+06   .9986168 -.0361589 -.0381706
T 1124  1 .6193934E+08   1000000E+01 -.3343E+04 -.4695E+06   .9944664 -.0252439 -.1019770
T 1125  1 .6181857E+08   1000000E+01 -.1323E+06 -.3035E+06   .9992842 -.0211074 -.0313947
T 1126  1 .6158412E+08   1000000E+01 -.1431E+06 -.3315E+06   .9976066 -.0363549 -.0588159
T 1127  1 .6122631E+08   1000000E+01  .3026E+06 -.2244E+06   .9996072  .0257458 -.0110741
T 1128  1 .6152143E+08   1000000E+01  .2633E+06 -.1977E+06   .9995659 -.0277852 -.0098017
T 1129  1 .6147453E+08   1000000E+01 -.5245E+05  .4135E+06   .9970016 -.0125644  .0763542
T 1130  1 .6152306E+08   1000000E+01 -.2115E+06  .5560E+05   .9979532 -.0576910  .0275879
T 1131  1 .6140463E+08   1000000E+01 -.4597E+05 -.6923E+05   .9994816  .0249794 -.0203139
T 1132  1 .6184304E+08   1000000E+01  .3557E+05  .3021E+06   .9984250  .0114404  .0549237
T 1133  1 .6176554E+08   1000000E+01  .8080E+05 -.2375E+05   .9978206 -.0658370 -.0044104
T 1134  1 .6157566E+08   1000000E+01  .5177E+06 -.7674E+05   .9980448  .0624401  .0027897
T 1135  1 .6143348E+08   1000000E+01 -.1154E+06  .1023E+06   .9992832 -.0378481 -.0008274
T 1136  1 .6190073E+08   1000000E+01 -.3479E+05  .1178E+06   .9997400  .0124486  .0191067
T 1137  1 .6192298E+08   1000000E+01 -.3558E+05  .2015E+06   .9990490  .0217320  .0378008
T 1138  1 .6157718E+08   1000000E+01 -.1409E+06 -.1145E+06   .9991084 -.0234796 -.0350876
T 1139  1 .6171481E+08   1000000E+01  .5296E+05  .3155E+06   .9958775  .0149549  .0894673
T 1140  1 .6146259E+08   1000000E+01  .8335E+05  .1390E+05   .9971790  .0448034 -.0602221
T 1141  1 .6119035E+08   1000000E+01 -.2349E+06 -.1703E+06   .9992829 -.0248527 -.0285671
T 1142  1 .6177676E+08   1000000E+01  .4057E+06 -.2478E+06   .9843831  .1696195 -.0471087
T 1143  1 .6154187E+08   1000000E+01  .6690E+05  .3024E+05   .9993485  .0295637  .0207038
T 1144  1 .6169151E+08   1000000E+01  .6024E+06 -.2103E+06   .9953266  .0867846 -.0423485
T 1145  1 .6155142E+08   1000000E+01  .4617E+05  .1623E+06   .9997274  .0119902  .0200363
T 1146  1 .6177055E+08   1000000E+01 -.2049E+06  .9625E+05   .9999195 -.0096249  .0082624
T 1147  1 .6191073E+08   1000000E+01  .8979E+05 -.1182E+06   .9988528  .0114666 -.0464929
T 1148  1 .6129173E+08   1000000E+01  .3929E+06 -.9204E+05   .9919296  .1193659 -.0427482
T 1149  1 .6130230E+08   1000000E+01 -.1894E+06 -.7246E+05   .9982707 -.0559603 -.0180029


Beam envelope window

This window appears automatically when ray tracing is carried out. It displays the horizontal (X, top) and vertical projections of the rays traced during any of the raytracing operations. The maximum number of rays that is displayed in the TRACE option is defined in the Raytracing control panel.

The plot can be cleared using the Clear button and copied as a graphic object using the Copy button. For the scaling commands see Scaling below.

The following items are displayed. The colours used on the plots can be defined using the Configure Ray plot window.
Feature | Default appearance | Comments
Rays | Yellow lines | The minimum axial spacing of the points on the rays is defined on the Raytracing control panel. Fewer points means that the graphs refresh faster. If the rays show discontinuities, this is probably where the DE solver has changed the step size and repeated a step. Avoid this by using a fixed maximum step size (also on the Raytracing control panel).
Beam axis and scale lines | Grey horizontal lines | The beam axis is thicker. the spacing of the scale lines is selected automatically and is printed on the plot. Find the coordinates of any point on the plot by hovering the mouse over that point. See Scaling below.
Active elements | Grey rectangles | Elements are labeled using their short code. The labeling alternates top-bottom to try to avoid problems in overlapping elements. This is generally not successful....
Source | Vertical blue line |
Slits | Vertical red line. |
Screens | Vertical green line |
Tubes | Horizontal blue lines | Beam tubes may not be visible if the vertical extent of the plot is smaller than the tube diameter.

Scaling
The horizontal and vertical scales can be adjusted using the commands in the green boxes.

Horizontal
Click Auto to restore the horizontal scale to the default (all elements from source to last screen are visible).
To zoom in to a smaller region of the axis...
either:
· Uncheck auto and type the upper and lower z limits into the two boxes.
or
· Click the Zoom button [image] and then click the lower and upper ends of the required zoom region.

Vertical
Click Auto to restore the vertical scales to the default (X and Y scaled independently to display the full extent of all rays).

To display both projections on the same vertical scale:
Enter the required vertical scale (full height in mm) into the yMax box and uncheck Auto.

Appearance
The colours used to display each element can be changed using the 'Rubik' button
This displays the Ray plot configuration dialog.


Viewing screens

Viewing screens can be inserted at any point along the system axis (even in impractical locations like the centre of a lens) and are used to accumulate the beam profile and statistics at that point.

The viewing screen window appears whenever one or more screens are present in the system. Each screen has its own tab along the top of the window. At the end of each raytracing run the tabs are updated with the beam properties at the defined axial position of the screen.

Five phase space projections (x-y, x-th, y-ph, th-de, ph-de) can be displayed and a comprehensive set of beam statistics for x,y,th,ph and de is listed.

Projection selection tab (x-y | x-th | y-ph | th-de | ph-de)
Allows the phase space projection to be selected. The scale and appearance settings for each projection are stored independently.

Controlling the appearance
The scale and appearance of the plot is controlled in a set of tabs:
Scale

The plot is always centred on the mean values of the selected parameters and these controls allow the size of the plotting area to be defined.

When the Auto box is checked, the plot area is always set to the total range of the parameters. When it is unchecked the values entered in the scale boxes are used.
Appearance

Colours Selects the colour palette used for the plots. Options are:
Rainbow | A false colour palette loosely based on the visible spectrum going from blue to red.
Thermal | A scale going from dark red to white loosely based on a 'heat' spectrum.
Grey + | A grey scale going from black to white.
Grey - | A grey scale going from white to black.
ZnS phosphor | A green palette fancifully supposed to look like a green phosphor.

Pixels Selects the number of pixels that the plot is sampled into. There is a fairly obvious interdependence between pixels, total number of rays in the plot, plot area and the quality of the plots.

Show all pixels with at least 1 ray. A pixel's colour is determined from its ray count by linear scaling relative to the maximum ray count. This can mean that some pixels with small ray counts are not displayed. When this box is checked, all pixels containing at least one ray are displayed with the lowest colour level. In practice this only makes a difference when large numbers of rays have been traced.
Filtering

This is an experimental feature (which is probably not working yet) to allow the optimum shape of intermediate (collimator) slits to be investigated. This works by allowing you to select only rays that fall within a distance of the central ray in the selected screen for plotting at intermediate screens.

When the Show only ... box is checked then only the rays which fall inside an area defined by the shape and size boxes will be used for plotting. This allows the ideal shape of collimator slits to be viewed directly.

Copy

These buttons copy the data in the window.
Image: Copy the beam spot image to the clipboard.
Table: Copy the beam statistics in CSV format (paste into Excel).

Ray count
This shows the total number of rays plotted. Comparing this with the number of rays traced gived the fraction of the beam intercepted by slits or tubes.

Beam statistics
This table shows the mean, full width at half maximum and the total spread of all five beam parameters.

Axial offset
These buttons allow the screen to slide along the beam axis, for example to investigate astigmatism or depth of focus. Each click of an up or down button displaces the screen plane by the distance selected in the box and the plots are re-displayed for the new position. Note that this is done by linear projection, and so can only sensibly be used in field-free regions. The actual position of the screen is displayed in the caption of the window and above the plot.

The Reset button restores the screen position to its design value.

This feature can be informative and entertaining...!


Element definition window
Main menu: New | Element
From the System definition window: Add, or Edit or double-click on selected element

This dialog defines the position and type of each element in a system The type-specific parameters for each element are defined by a further set of specialised dialogs which are accessed from the Edit details button.

This window defines an optical element as part of a system.

· The top half defines the type of the element and gives access to changing its properties.
· The bottom half defines the position of the element within the system.

Define element
Load from file Save to file | These buttons allow the element specification to be loaded from or saved to a named file. When an element is loaded from a file, all the fields in the top half are set from the data in the file.
Element type | This drop-down box selects the type of element. Options are: · Source · Slit · Active element · Screen · Beam tube · Link block
Edit details | Opens the Element editing window for the specific element type.
Long description | Description of the TYPE of element (not its role in the system)
Headline parameters | These parameters define the 'design' function and nominal dimensions of an active element device. These must be defined to allow the Multipole element definition window to initialise correctly.

Parameters within the system
Distance from source | The designed distance of the geometrical centre of the element from the source.
Design axial rotation | Any rotation of the element about the axis that is required by the desgn. Not to be confused with the rotation misalignment, RHO. This can be entered in mr or degrees according to the mr/deg selection button.
Description in system | A description of the role of this element in the system, e.g. 'Object slit', 'Image screen'. This may be different from the long description of the element type referred to above.
Translational misalignment | The displacement error of the centre of the element from the designed position.
Rotational misalignment | Rotational error of the element about its primary axes.


Source definition window
From the Element definition window: Edit details

Allows the parameters of an "ion source" to be defined.

Long description
A description of this source.

Ion | Electron
Specfies the type of charged particle.

Ions
The true rest mass of the ions can be specified in two ways:

· From a lookup table of nuclide masses. The compilations used here is the Ame2003 atomic mass evaluation (II)" by G.Audi, A.H.Wapstra and C.Thibault, Nuclear Physics A729 p. 337- 676, December 22, 2003, which is available from http://www.nndc.bnl.gov/masses/mass.mas03. This uses the isotope number, A and the atomic number Z as indices into the table.

· By entering the required mass (in a.m.u) into the data entry box.

The integer charge, Q, must be entered.

Electrons
When the electron tab is selected a charge of -1 and the accepted electron rest mass are used.

Energy
The mean energy (in MeV) of the ions emitted by the source.

Energy spread
These parameters determine the range of ion energy (either rectangular width or gaussian fwhm depeneding on the Energy distribution option in the raytracing control panel .). Energy spread can be specified as a combination of a fixed value plus a percentage of the mean energy.

Full width and full angle

These parameters determine the limiting emittance of the source which is used in some rayset generation options.


Slit definition window
From the Element definition window: Edit details

This window is used to define the shape and size of slit apertures.

Three types of aperture can be selected using the drop-down list:
Rectangular
The aperture is a rectangular opening with the sides parallel to the X and Y axes of the element. The full width is given by the entered values.
Elliptical
The aperture is an elliptical opening with the axes parallel to the X and Y axes of the element. The lengths of the aes are given by the entered values.
Grid
The aperture is a regular square grid with the axes parallel to the axes of the element. When grid is selected, the screen changes to
to allow the repeat distance and bar width in each direction to be defined. The origin of the grid (the start of a bar in each direction is at the origin of the element. This can be displaced if required using the X and Y offset values of the element. Any ray striking a grid bar is stopped.
This feature allows grid shadow patterns to be explored.

The Aperture file option on the drop-down box is not yet implemented.


Multipole element definition window
From the Element definition window: Edit details

This window allows the individual field harmonics or axial fields which comprise an active element to be specified and adjusted.

See here for a detailed description of how the fields are calculated and parameterised.

This window has a lot of functionality: keep reading...

The left hand side is for entering parameters; the right hand side displays the resulting field for the selected harmonic.

Long description
A description of this type of element.

Headline parameters
These parameters describe what the element is intended to be, regardless of additional harmonics, fringing fields etc. So an element designed as a magnetic quadrupole is always treated as a quadrupole even though it may have sextupole field components. The headline information is used in many ways from laying out the system to calculating k-values and pole-tip fields. The headline dimensions are used to determine the geometric limits of the element. The effective length is determined (for information only!) by integrating the field along the axis, and is not used in the calculations.
Magnetic / Electrostatic | The type of field generated. An element may NOT contain mixed magnetic and electrostatic harmonics.
The harmonic order | The primary multipole function for the device. This can be cylindrical harmeonics from dipole to 12-pole, (n = 1 .. 6) or axial fields.
Design length | This is the geometric length of the device which will be used for laying out the system. This would usually be the points that you measure to, such as the length of the iron yoke of a quadrupole. The geometric centre of the device is taken to be at the mid-point of the design length.
Design radius | The design radius is used for calculating the fields from the excitations (pole voltage or pole-tip field) assuming the headline field type. Individual harmonics may have a different radius from this (if that really means anything...!).
Design turns per pole | (For magnetic devices only) this value is used to relate coil current to excitation.

Multipoles and axial fields
This section defines the properties of all multipoles in the element. An element must have at least one multipole defined, and this should match the headline field type (though this is not checked and could cause unpredictable behaviour). Although it is possible to define more than one harmonic of each type, this can lead to severe confusion and is strongly deprecated (later releases will check for this).
Add | Creates a new multipole. This shows a dropdown list of available multipoles. Select and click the new Add button to create the multipole. Click Cancel to abandon the operation.
Remove | Removes the selected multipole. It is not possible to remove all multipoles.
Multipole selection buttons | All the defined harmonics are listed here. Use the buttons to select the harmonic to be defined or investigated.
Bore radius | The effective bore radius for each harmonic. In principle it is possible to make each radius different and different from the headline radius, but it is not clear why you would want to do this...
Phase angle | The zero angle for each harmonic relative to the X axis of the element. This choice of origin gives focusing/defocusing in the X and Y planes of magnetic quadrupoles but the phase angle may need to be changed for other field types. Electrostatic quadrupoles require a phase angle of -90 degrees to have the same function.
Relative strength | The fields for each harmonic are calculated using the primary pole voltage or pole-tip field scaled by this parameter. Thus the relative strength for the primary harmonic should be 1.0 to avoid confusion. Contaminant fields would be expected to have smaller values.

Fringing fields
The fringing fields (FF) are defined by the parameters Z0, ZL and C0..C4 for each fringing field (entrance and exit) (see here ).

These values are entered into the FF parameter grids. If the "==>>" box is checked, the Exit FF is defined to be identical to the entrance FF and only the entrance FF parameter grid is enabled.

To define a sharp cut-off fringing field (SCOFF) set ZL to zero.

Effective length
The effective length of a multipole is not used by the raytracing calculation, but its value may be of interest. The green box shows the effective length (defined as the integral of Bdl divided by B(0)) of the selected field component at the X,Y coordinates defined in the X,Y boxes. If the effective length is undefined (B(0) = 0, for instance), the box turns orange.

It may be required to set the effective length to a pre-determined value, for instance to compare raytracing results with matrix calculations. This can be done by clicking the 'Change Z0...' button. This adjusts the values of Z0 for the entrance and exit fringing fields so that the calculated effective length is equal to the specified value. A useful approximation is that
effective length = geometric length + 1.1 x radius,
and this is suggested by default.

Field plots
The field variation for the selected multipole is displayed in the plots on the right of the window.

Three types of plot can be selected:
Axial plot | Field as a function of axial position (z) at constant X,Y.
Symmetry plot | The sum F(X,Y) + F(-X,-Y) as a function of z at constant X,Y. This should be identically zero for even order multipoles. This option was added as an aid to debugging the field calculations, and has no obvious practical application if everything is working correctly.
Harmonic plot | Field at constant radius as a function of azimuth angle (from 0 to 2.pi) at constant z.

These are selected using the radio buttons. This reveals the appropriate entry boxes for X, Y, z and r.

Any one, or all of the three field components (X, Y, Z) can be plotted. This is selected using the
X |Y |Z |All
buttons at the top of the page.

In single graph (X, Y or Z) mode, the plot can be copied to the clipboard either as a graphical object (BMP or Windows Metafile) or as a set of data points. This is done using the buttons in the Copy as .. box.

Load measured fields
A file containing a measured fringing field profile can be loaded in and displayed on the same plots as the calculated fields. The parameters can then be adjusted to optimise the match.

See Matching to measured fields


Matching to measured fields

Clicking Load measured fields in the Multipole element definition window allows a fringing field profile (as a set of Z,F pairs to be loaded and compared with the calculated field.

The fields should be prepared as a CSV file with two columns. The first column contains the axial position, the second column the field.

The example below is Om52_Axial_Field.csv, which is installed in the Examples folder and goes with the element data file OM52.txe.

[The measured fields are digitised from figure 5(b) of Breese, Grime et al., An extended magnetic quadrupole lens for a high-resolution nuclear microprobe, Nucl. Instr. and Meth. B 158 (1999) 48 . This article is installed in the examples folder . ]

This file is loaded by clicking Load measured fields.
This brings up the dialog shown below where the file is selected together with the field component (X,Y or Z) that was measured.

When Load is selected, the points are added to the graph for the selected field component.

The various field parameters can then be adjusted to optimise the fit. At the moment this has to be done by hand and eye. At some point in the future a chi2 display and even a fitting routine may be implemented.


Link block definition window
From the Element definition window: Edit details

Link blocks are groups of parameters whose numerical value is related to a common link block value by a simple arithmetic relationship. Examples of the use of link blocks are to assign two quadrupole lenses to the same power supply or to be able to move a group of elements along the axis while maintaining their relative spacing.

Link blocks are created as a virtual element in the System definition window and they are defined using the Link block definition window:

This example specifies that the pole-tip fields of elements 6 and 7 are respectively 1 and -1 times the link block value. The value can be defined in this dialog, or more conveniently using the VALUE text command in the console window.

The ripple parameter is not yet implemented.

Up to five parameters can be link in a single block. Larger numbers can be linked by linking the values of the groups together.


Optimisation window (OPTIM)
Main menu: Raytracing | Optimise
Text command: OPTIM

This panel launches an optimisation run to achieve a specified goal using specified system parameters.

Description - Load a previous run
Each optimiser run is stored in a list which is saved with the system data file so that previous runs can be recalled easily. To do this the run must be given a unique name (in the Description entry window).
Previously stored runs can be re-loaded by selecting them in the list and clicking Load.

Clear item and Clear list allow unwanted runs to be removed.

Goal definition
The following statistical properties of the beam at the selected viewing screen can be optimised:
X fwhm | FWHM of all X values
Y fwhm | FWHM of all Y values (these options will define a line focus)
Radius fwhm | FWHM of the distance from the centroid position (use to define a spot focus)
X extent | The total range of X values
Y extent | The total range of Y values
Total area | The product of X-extent and Y-extent
Position (um) | The (X,Y) centroid position
Astigmatism | The axial distance between the points where the X and Y projections of the ray cross the Z axis.
% within radius | The percentage of all rays traced that lie within a defined radius of the centroid.
Mean divergence (mr) | The centroid of the (th,ph) divergences.
Mean X and th | Set the mean X and th to defined values simultaneously.
Mean Y and ph | Set the mean Y and ph to defined values simultaneously.
Limiting emittance (total) | The product of the total extents of X, Y ,th and ph.
Limiting emittance (X) | The product of the total extents of X and th
Limiting emittance (Y) | The product of the total extents of Y and ph

The goal is then further specified using options selected from
is minimised | the goal is mimimised
is maximised | the goal is maximised
is equal to | the goal is set equal to values which are entered into boxes which appear according to context.

Note that not all options of target goals and optimiser conditions are sensible!

The Goal multiplier defines a value which multiples the goal value. This may help to improve the sensitivity and speed of locating slowly varying optima.

Rayset generation
This box determines how the rayset used to calculate the goal values is generated.
Rays are selected from the circumference of the limiting phase space defined by the Diameter and Divergence parameters. The emittance area can be Rectangular or Elliptical and the rays can be selected in regular Steps or Randomly. the total number of rays traced is defined in the Rays entry box. In the stepped option the X-th and Y-ph phase spaces are stepped synchronously.

Live ray plot selects whether the rays are displayed in the Beam envelope window as they are traced. Unchecking this may help to speed up the process.

Parameter selection
The parameters which are varied to achieve the defined goal are selected here.
· Parameter codes entered in the green box are transferred to the parameter list using <CR> or the >> button.
· Parameters must have a non-zero value.
· Parameters can be deleted using the Delete or Delete All buttons.

The Initial stepsize taken by the optimiser can be set to Wide, Normal or Narrow. This can be useful to control the search range. For instance if you are fine tuning an existing optimum, select Narrow to avoid the program going off down an other brach of the parameter surface.

Stopping conditions
These parameters define when the optimiser stops.
Maximum iterations. The maximum number of iterations permitted. Can be used to stop the run if it gets trapped.
Accuracy. [Low, Normal, High] This is used to define the precision of the minimum, related to the radius of the search region surrounding a located minimum.

Start
This starts the optimiser.

Progress can be monitored through the monitor window, which displays the relative value of the optimiser goal for the most recent iterations.

An emergency stop button is also displayed:

This runs as a separate application. Clicking the stop button or closing the WinTRAX Sentry program from the taskbar will stop the optimiser.


Aberration coefficient calculation (GENFIT)
Main menu: Raytracing | GenFit
Text command: GENFIT

GENFIT was the name of the command used in OXRAY for this process. It has proved too useful to abandon...

This panel controls the calculation of aberration coefficients using the matrix inversion method described in the WinTRAX paper.

Description - Load a previous run
Each optimiser run is stored in a list which is saved with the system data file so that previous runs can be recalled easily. To do this the run must be given a unique name (in the Description entry window).
Previously stored runs can be re-loaded by selecting them in the list and clicking Load.

Clear item and Clear list allow unwanted runs to be removed.

Aberration coefficients are calculated by accumulating the ray coordinates at the selected screen and using these to fit a polynomial of the independent parameters used to generate the rays.

The parameters are selected by entering them into the grid. Use Add to enter a new parameter, use Delete to remove the selected parameter.

The columns in the grid are:
Parameter | The code for the parameter (described here )
Steps | The number of values of this parameter to trace. This must be 1 greater than the maximum order coefficient required for this parameter (e.g. to get terms in th^3, at least 4 steps of th must be traced.
Range | The total range of values for this parameter (in WinTRAX unts).
Mean | The central value of the range
Max order | Not yet implemented

Start
This starts the GenFit run with the conditions defined. A progress screen is displayed:

This runs as a separate application. Clicking the stop button or closing the program from the taskbar will stop the run.

The rays are plotted onto the Beam envelope window as they are traced when the Live Ray plot Enabled box is checked. This can introduce a significant delay as the rays are redrawn, especially with large raysets, so the frequency of plot updates can be controlled using the Refresh after ... rays box. This defines how many rays are accumulated between updates of the beam envelope window.

Results
Results are displayed as two tables of coefficients and entrance and exit ray coordinates.

Either of these can be exported to a CSV file (for Excel) using the appropriate buttons. The coeffcients can also be exported in a format for MaxI - a helper program to find optimum slit settings using Monte Carlo methods. More about this in later releases.


Matrix calculation
Main menu: Raytracing | Matrix
Text command: (none)

Calculates the first order optical transfer matrices between two XY planes along the axis.

The two points are defined by typing the z position of required planes. On entry these boxes are filled with the object plane (z = 0) and the final image plane location.

Two (2 x 2) matrices are returned, for the X and Y planes. The elements for the x-plane are:
A (x | x)
B (x | th)
C (th | x)
D (th | th)
For the y-plane replace x with y and th with ph.

The DetX and DetY values contain the determinant of each matrix.

If Z1 is a first order image of Z0, then B = 0, Det = 1 and D is the demagnification

The principal planes relating to the imaging between the selected points are calculated and displayed in the lower box. Hx1 and Hx2 are the entrance and exit principal planes for the X- plane imaging, Hy1 and Hy2 are those for the Y-plane. The locations are specified as the distance from the system object (z=0).


System field plots
Main menu: Fields | Show field plots
Text command: (none)

Displays a plot of the electrostatic or magnetic fields in the system as a function of distance along the axis.

Magnetic | Electrostatic These buttons define the type of field displayed.

X, Y (um) These boxes define the distance off axis where the field is calculated

Symmetry When this is checked the value displayed is the difference between the field values at (x, y) and those at (-x, -y). For axially aligned even-order multipoles, this should always be zero, so this option can be useful for tracking down obscure field calculation problems (e.g., overlooked misalignments).

Refresh This starts the calculation. This MUST be clicked after any changes to the above values.


Spot fields
Main menu: Fields | Spot fields
Text command: (none)

Displays the full-precision numerical value of the fields (Tesla and V/m) at a single point in the system.

The position is defined by entering X, Y and Z values (in metres) into the boxes in the Position panel.

The Field calculation in ... selection list allows the field to be displayed either relative to the system, in which case Z is defined relative to the source (Z=0) or relative to the selected element.
If an element is selected then the fields are shown both as the total field from all elements at the selected point and as the field generated only by the selected element at that point.

Use the >> button to force a refresh of the values if required.


Development history


What's new?
 Previous Top

Date
Bug fix,
New feature Code re-org
Version
Description
07-01-2019
B,N,C
1.1.156
New release with several bug fixes and new features. Most important is the change to XML data files which will allow for future upgrades without having to modify the file format.
This version will read the existing binary .TXS and .TXE files, but new files will be written as XML .TXSX and .TXEX files.

WinTRAX is now shipped with MaxI which allows the slit conditions for maxmimum acceptance to be calculated using a Monte- Carlo method using the aberration coefficients generated by GENFIT. The help file for this has NOT yet been written...!
10-11-2017
B,N,C
1.1.091
Many new features and bug fixes.
04-09-2013
N
1.0.071
Added the DVAL parameter to assist with investigating parameter dependencies.
9-11-2012
N
First release.